class ProvidePhoneNumber {
	modal;
	laterModal;
	providePhoneNumberLaterButton;
	phoneNumberInput;

	constructor() {
		this.modal = document.querySelector('#modal');
		this.laterModal = document.querySelector('#laterModal');
		this.providePhoneNumberLaterButton = document.querySelector('#providePhoneNumberLaterButton');
		this.phoneNumberInput = document.querySelector('#phoneNumberInput');
		this.providePhoneNumberLaterButton.addEventListener('click', () => {
			this.setVisible(this.laterModal);
		});
		document.querySelector('#laterModalBack').addEventListener('click', () => {
			this.setInvisible(this.laterModal);
		});
		document.querySelector('#repeatPhoneNumberModalBack').addEventListener('click', () => {
			this.setInvisible(this.modal);
		});
		document.querySelector('#repeatPhoneNumberModalContinue').addEventListener('click', () => {
			this.evaluatePhoneNumbersAndSubmit();
		});
		document.querySelector('#providePhoneNumberContinueButton').addEventListener('click', () => {
			this.clearModalInput();
			this.showErrorBanner(false);
			this.setVisible(this.modal);
		});
	}

	setInvisible(ref) {
		window.utils.changeDisplay(ref, 'hidden', 'block');
	}

	setVisible(ref) {
		window.utils.changeDisplay(ref, 'block', 'hidden');
		const isMobile = !!/(iPhone|Android)/.test(window.navigator.userAgent);
		if (isMobile) {
			ref.classList.add('mobileDrawer');
			document.dispatchEvent(new Event('initDrawerPopup'));
		}
	}

	arePhoneNumbersEqual() {
		const phoneNumber = document.getElementById('phoneNumberInput').value.trim();
		const repeatedPhoneNumber = document.getElementById('mobile').value.trim();
		return phoneNumber === repeatedPhoneNumber;
	}

	evaluatePhoneNumbersAndSubmit() {
		if (this.arePhoneNumbersEqual()) {
			document.querySelector('#submit').click();
		}
		else {
			this.setInvisible(this.modal);
			this.showErrorBanner(true);
		}
	}

	clearModalInput() {
		const phoneNumberInput = document.getElementById('mobile');
		phoneNumberInput.value = '';
	}

	showErrorBanner(visible) {
		const errorBanner = document.getElementById('errorBanner');
		if (visible) {
			window.utils.changeDisplay(errorBanner, 'block', 'hidden');
		}
		else {
			window.utils.changeDisplay(errorBanner, 'hidden', 'block');
		}
	}
}

document.addEventListener('DOMContentLoaded', () => {
	window.providePhoneNumber = new ProvidePhoneNumber();
});
